# Exercise NTN, Containers rebalancing (GLM textbook, page 212)

# DATA
set Cities;
param Cost {Cities,Cities};
param Excess {Cities};

# VARIABLES
var x {Cities,Cities} >=0;

# CONTRAINTS
# Flow conservation constraints for each city j (i = predecessor; k = successor)
subject to Flow_conservation {j in Cities}:
  sum {i in Cities} x[i,j] - sum {k in Cities} x[j,k] = -Excess[j];

# OBJECTIVE
# Minimize the cost
minimize z: sum {i in Cities, j in Cities} Cost[i,j] * x[i,j]; 

#####################
data;

set Cities := Ams Ber Mun Par Mil Bar Mad;

param Cost:	Ams		Ber		Mun		Par		Mil		Bar		Mad :=
Ams			9999	  30	  40	  20	9999	9999	9999
Ber			  30	9999	  30	9999	9999	9999	9999
Mun			  40	  30	9999	  55	  30	9999	9999
Par			  20	9999	  55	9999	  30	  50	  70
Mil			9999	9999	  30	  30	9999	  30	9999
Bar			9999	9999	9999	  50	  30	9999	  25
Mad			9999	9999	9999	  70	9999	  25	9999;

param Excess :=
Ams	-10
Ber	 20
Mun	 50
Par	 20
Mil	-50
Bar	-20
Mad	-10;

end;
